## IMPGame,
## by Gefa
## www.gefa.altervista.org

import psp2d, pspsnd, pspos
import string
import random
import time

splash = psp2d.Image('splash/splash.png')
timSplash = 0

padImg = psp2d.Image('pad.png')
uno = psp2d.Image('1.png')
due = psp2d.Image('2.png')
tre = psp2d.Image('3.png')
quattro = psp2d.Image('4.png')
cinque = psp2d.Image('5.png')
choose = psp2d.Image('choose.png')

alphaMask = 0
mask = psp2d.Image(480, 272)
mask.clear(psp2d.Color(255,255,255,alphaMask))
font = psp2d.Font('font.png')

screen = psp2d.Screen()

nlettera = -1
lettere = ['A','B','C','D','E','F','G','H','I','L','M','N','O','P','Q','R','S',\
           'T','U','V','Z','Y','W','X','K','J']

nparola = [] # Parola "mascherata"

cf = open("conf.ini","r")
linee = cf.readlines()
splittata = string.split(linee[0])
path = splittata[2]

def init(lingua = None, path_ = None):
    parola = ''
    nparola = []
    if path_ == None:
        fl = open(path,"r")
        linee = fl.readlines()
        linea = linee[random.randint(0,len(linee)-1)]
        splittata = string.split(linea,",")
        if lingua == 0: # Ita
            parola = splittata[1].upper()
        if lingua == 1: # Eng
            parola = splittata[0].upper()
        if lingua == 2: # Fra
            parola = splittata[2].upper()
        if lingua == 3: # Spa
            parola = splittata[4].upper()
        if lingua == 4: # Ted
            parola = splittata[3].upper()
            
        pos = 0
        for elemento in parola:
            if pos == 0:
                nparola.append(parola[0])
            elif pos == len(parola)-1:
                if lingua != 3: nparola.append(parola[len(parola)-1])
                else: nparola.append(parola[len(parola)-2])
            elif elemento == " ":
                nparola.append(" ")
            else:
                nparola.append('-')
            pos += 1
    else:
        fl = open(path_,"r")
        words = fl.read()
        parola = (words.split(',')[random.randint(0,len(words.split(','))-1)]).upper()
        pos = 0
        for elemento in parola:
            if pos == 0 or pos == len(parola)-1:
                nparola.append(elemento)
            else:
                nparola.append('-')
            pos += 1
    #print parola, nparola
    return parola, nparola

vite = 4

def insert(lettera):
    global vite
    pos = 0
    sostituito = 0
    for elemento in parola:
        if elemento == lettera:
            nparola[pos] = lettera
            sostituito = 1
        pos += 1
    if sostituito == 0:
        vite -= 1

oldpad = psp2d.Controller()

gioco = -1 # splash
gameMode = 'default'
sceltaDizionario = 0
dizionari = pspos.listdir("dicts/")
scelta = 1
terzascelta = ['Italiano', 'English', 'Francais', 'Espanol', 'German']
nterzascelta = 0

while True:
    pad = psp2d.Controller()

    if gioco == -1:
        screen.blit(splash, 0, 0, splash.width, splash.height, 0, 0, True)
        screen.blit(mask, 0, 0, mask.width, mask.height, 0, 0, True)
        mask.clear(psp2d.Color(255,255,255,alphaMask))
        if timSplash > 150 and alphaMask < 254: alphaMask += 3
        timSplash += 1
        if timSplash == 250:
            gioco = 0
            alphaMask = 254
        
    if gioco == 0: ## Menu Principale
        screen.blit(cinque, 0, 0, cinque.width, cinque.height, 0, 0, True)
        if scelta == 1:
            font.drawText(screen, 20, 130, "< Default Game >")
            font.drawText(screen, 20, 160, " Choose Dictionary ")
            font.drawText(screen, 20, 190, " Language: %s "% terzascelta[nterzascelta])
            font.drawText(screen, 20, 220, " Exit  ")
            if pad.cross and not oldpad.cross:
                alphaMask = 254
                vite = 4
                parola, nparola = init(nterzascelta)
                time.sleep(0.5)
                gameMode = 'default'
                gioco = 2
        elif scelta == 2:
            font.drawText(screen, 20, 130, " Default Game ")
            font.drawText(screen, 20, 160, " < Choose Dictionary >")
            font.drawText(screen, 20, 190, " Language: %s "% terzascelta[nterzascelta])
            font.drawText(screen, 20, 220, " Exit ")
            if pad.cross and not oldpad.cross:
                gioco = 1
        elif scelta == 3:
            font.drawText(screen, 20, 130, " Default Game ")
            font.drawText(screen, 20, 160, " Choose Dictionary ")
            font.drawText(screen, 20, 190, "< Language: %s >"% terzascelta[nterzascelta])
            font.drawText(screen, 20, 220, " Exit  ")
            if pad.cross and not oldpad.cross and nterzascelta != 5:
                nterzascelta += 1
            if pad.cross and not oldpad.cross and nterzascelta == 5:
                nterzascelta = 0
        elif scelta == 4:
            font.drawText(screen, 20, 130, " Default Game ")
            font.drawText(screen, 20, 160, " Choose Dictionary ")
            font.drawText(screen, 20, 190, " Language: %s "% terzascelta[nterzascelta])
            font.drawText(screen, 20, 220, "< Exit >")
            if pad.cross:
                break
            
        if pad.down and not oldpad.down and scelta != 4:
            scelta += 1
        if pad.up and not oldpad.up and scelta != 1:
            scelta -= 1

    if gioco == 1:
        screen.blit(cinque, 0, 0, cinque.width, cinque.height, 0, 0, True)
        font.drawText(screen, 20, 130, " Default Game ")
        font.drawText(screen, 20, 160, " < Choose Dictionary >")
        font.drawText(screen, 20, 190, " Language: %s "% terzascelta[nterzascelta])
        font.drawText(screen, 20, 220, " Exit ")
        screen.blit(choose, 0, 0, choose.width, choose.height, 0, 0, True)
        y = 56
        i = 0
        for dict in dizionari:
            if i == sceltaDizionario:
                screen.drawText(131, y, '-> '+dict.split('.')[0]+' <-', psp2d.Color(0, 0, 255))
            else:
                screen.drawText(131, y, dict.split('.')[0], psp2d.Color(0, 0, 255))
            y += 10
            i += 1
        if pad.up and not oldpad.up and sceltaDizionario != 0:
            sceltaDizionario -= 1
        elif pad.down and not oldpad.down and sceltaDizionario != len(dizionari)-1:
            sceltaDizionario += 1
        elif pad.start and not oldpad.start:
            alphaMask = 254
            vite = 4
            parola, nparola = init(path_ = 'dicts/'+dizionari[sceltaDizionario])
            time.sleep(0.5)
            gameMode = 'personalizzato'
            gioco = 2
        elif pad.triangle and not oldpad.triangle:
            gioco = 0
            scelta = 1
        
    if gioco == 2: ## Gioco
        if pad.select and not oldpad.select:
            nparola = []
            nlettera = -1
            gioco = 0
        if vite == 4:
            screen.blit(uno, 0, 0, uno.width, uno.height, 0, 0, True)
        if vite == 3:
            screen.blit(due, 0, 0, due.width, due.height, 0, 0, True)
        if vite == 2:
            screen.blit(tre, 0, 0, tre.width, tre.height, 0, 0, True)
        if vite == 1:
            screen.blit(quattro, 0, 0, quattro.width, quattro.height, 0, 0, True)
        if vite == 0:
            screen.blit(cinque, 0, 0, cinque.width, cinque.height, 0, 0, True)
        
        if vite != 0:
            font.drawText(screen, 125, 170, lettere[nlettera])
            if "-" in nparola:
                screen.blit(padImg, 0, 0, padImg.width, padImg.height, 0, 0, True)
                font.drawText(screen, 50, 70, ''.join(nparola))
            
                if pad.left and not oldpad.left and nlettera != 0:
                    nlettera -= 1 
                if pad.right and not oldpad.right and nlettera != 25:
                    nlettera += 1

                if pad.cross and not oldpad.cross:
                    if not nlettera == -1:
                        insert(lettere[nlettera])
                    else:
                        nlettera = 0
            elif not "-" in nparola:
                font.drawText(screen, 50, 70, ''.join(nparola))
                font.drawText(screen, 70, 120, "YOU WON!")
                if pad.start and not oldpad.start:
                    nparola = []
                    if gameMode == 'default':
                        parola, nparola = init(nterzascelta)
                    else:
                        parola, nparola = init(path_ = 'dicts/'+dizionari[sceltaDizionario])
                    vite = 4
        if vite == 0:
            font.drawText(screen, 50, 70, "YOU LOST!")
            font.drawText(screen, 13, 120, "THE WORD WAS:")
            font.drawText(screen, 13, 160, parola)
            if pad.start and not oldpad.start:
                alphaMask = 254
                nparola = []
                if gameMode == 'default':
                    parola, nparola = init(nterzascelta)
                else:
                    parola, nparola = init(path_ = 'dicts/'+dizionari[sceltaDizionario])
                vite = 4

        if alphaMask != 0:
            alphaMask -= 2
            mask.clear(psp2d.Color(255,255,255,alphaMask))
            screen.blit(mask, 0, 0, mask.width, mask.height, 0, 0, True)
        
    oldpad = pad
    screen.swap()
